/**********************************/
/*  L Y N X  -  TextOut-Testprg.  */ 
/*                                */ 
/*  Matthias Domin                */
/*  6. September 1997             */
/**********************************/
 
#include <lynx.h>

#define SCREEN 0xa000

#define TRUE  1
#define FALSE 0

char szOut[] = "You have 0000 points";

/* standard palette */ 
char pal[] = {
   0x00,0x00,0x08,0x00,0x00,0x08,0x08,0x08,0x04,0x00,0x0F,0x00,0x00,0x0F,0x0F,0x0F,
   0x00,0x08,0x00,0x80,0x88,0x80,0x08,0x88,0x44,0x0F,0x00,0xF0,0xFF,0xF0,0x0F,0xFF
};

/*********************/
/* wait for a button */
/*********************/
char WaitButton()
{
   char key;
   while ( (key = joystick) == 0)
      ;
   /* wait for the button to be released */
   while ( joystick )
      ;
   return key;
}

/**************************************************************************
**                                                                       **
**                                                                       **
**************************************************************************/
main() 
{
   int xpos, ypos;
   int score, bonus;

/*   char szOut[] = "You have 0000 points"; */

#asm
   lda #$c        /* Vector space + ROM space --> FFFA-FFFF + FE00-FFF7 */
   sta $fff9      /* MAPCTL */
   cli
#endasm

   /* set up buffer : display buffer == render buffer, no collision buffer */
   SetBuffers(SCREEN,(char *)0,(char *)0 );

   /* set the palette */
   SetRGB(pal);

   /* fill the screen with 16 colored stripes */
   /* so you can differ the transparent row 1 from the opaque rows 2-9 */
   for (xpos = 0; xpos < 16; xpos++)
      DrawFBox(xpos*10, 0, 10, 102, xpos);


   for (ypos = 0; ypos < 9; ypos++)
      TextOut(0, ypos*11, ypos+1, ypos, "Hello World!");

   WaitButton();

   /* Clear the screen */
   DrawFBox(0, 0, 160, 102, 0);

   score = 0x2000;
   bonus = 0x0500;

   score = BCDAdd(&score, &bonus);
   BCDToASCII(&score, &szOut[9]);
   TextOut(0, 30, 1, 2, szOut);

   score = BCDAddConst(&score, 0x0500);
   BCDToASCII(&score, &szOut[9]);
   TextOut(0, 50, 2, 3, szOut);

   WaitButton();

   /* Clear the screen */
   DrawFBox(0, 0, 160, 102, 15);
   TextOut( 0, 4*11, 2, 3, "TextOut() -> normal");
   TextOutExt(0, 5*11, 2, 3, "TextOutExt()", 0x110, 0x0200);
   TextOut( 0, 7*11, 2, 3, "TextOut() -> normal");

   WaitButton();

} 

